Improve page header title for deeply nested project structures (+ improved XSS resilience)
Category: UI Estimated time: 0.00 hour

Target version: 3.3.0   

Description

Some theme developers (or even Redmine core, see below) may wish to put the project breadcrumbs within the page header title on

a separate line, see screenshots attached.

Patch 0001 will add some extra span elements which make this possible for theme CSS. It also improves XSS resilience by using the

safe_join helper instead of manually declaring strings .html_safe, see here and here. This patch shouldn't change things for existing

themes and could therefore applied to core without any doubt, IMHO.

Patch 0002 actually changes Redmine's core CSS to take advantage of this and display the breadcrumbs on a separate line. I feel it

looks better this way, but I realize that this is just my opinion, so I would see this patch as optional and up for discussion.

Old:

 600 

New:

 600 

Related issues:

Related to Redmine - Feature #7848: Add class for project title in the header Closed 2011-03-13

Has duplicate Redmine - Defect #5261: Multiple level subprojects wrap around ... Closed 2010-04-07

Associated revisions

Revision 15256 - 2016-03-19 10:12 - Jean-Philippe Lang

Add additional markup to page_header_title to enable better styling (#21947).

Patch by Jan Schulz-Hofen.

Revision 15257 - 2016-03-19 10:13 - Jean-Philippe Lang

Put project breadcrumbs in page_header_title on separate line and use ellipsis if it's still too long (#21947).

Patch by Jan Schulz-Hofen.

Revision 15258 - 2016-03-19 10:14 - Jean-Philippe Lang

Font size for project breadcrumbs (#21947).

History

#1 - 2016-02-04 08:00 - Jan from Planio www.plan.io

- Description updated

#2 - 2016-02-04 08:08 - Jan from Planio www.plan.io

- Description updated

#3 - 2016-02-04 22:27 - Daniel Feliciano Branco

I have the same problem on some of my projects, so a +1 from me.

#4 - 2016-02-05 01:57 - Go MAEDA

- File screenshot-font-comparison.png added
http://makandracards.com/makandra/954-don-t-mix-array-join-and-string-html_safe
http://stackoverflow.com/questions/4191028/rails-3-0-2-arrayjoin-html-safe
https://www.redmine.org/attachments/15341
https://www.redmine.org/attachments/15342


Great. I think this should be included in Redmine core.

But breadcrumbs in small and bold font are hard to read with non HDPI devices, especially when displaying CJK characters.

 

I suggest changing the style to the following:

#header h1 .breadcrumbs { display:block; font-size: .6em; font-weight: normal; }

#5 - 2016-02-12 05:30 - Go MAEDA

- Target version changed from Candidate for next minor release to 3.3.0

Setting target version to 3.3.0.

#6 - 2016-02-12 05:40 - Jan from Planio www.plan.io

Go MAEDA wrote:

I suggest changing the style to the following:

 Sounds good to me! I must admit that I hadn't tested with CJK characters, but I agree that all texts should remain readable with all character sets, of

course!

#7 - 2016-03-19 10:15 - Jean-Philippe Lang

- Status changed from Needs feedback to Closed

- Assignee set to Jean-Philippe Lang

Changes committed, thanks.

#8 - 2016-08-22 03:02 - Go MAEDA

- Has duplicate Defect #5261: Multiple level subprojects wrap around into the menu added

#9 - 2016-11-30 12:30 - Ben Blanco

- File 2016-11-30_new_redmine_header.png added

- File 2016-11-30_old_redmine_header.png added

Hi,

I've upgraded to from 3.2.3 to 3.3.1, and now my header wraps even when they're short..

It's definitely cool that headers can be styled differently now, and wrap nicely when dealing with super-long-project-names, but for me we have two

sub-levels max, and our names are short, yet I used to have this:

 

Now I have this:
We use circle theme v.2.0.2

Any help/indication on how I can fix this wrapping?

#10 - 2016-12-01 14:57 - Toshi MARUYAMA

Ben Blanco wrote:

Hi,

...

 Please create new issue for feature request, because this issue has closed.

#11 - 2018-01-10 13:37 - Go MAEDA

- Related to Feature #7848: Add class for project title in the header added

Files

0001-Add-additional-markup-to-page_header_title-to-enable.patch 1.12 KB 2016-02-04 Jan from Planio www.plan.io

0002-Put-project-breadcrumbs-in-page_header_title-on-sepa.patch 1.11 KB 2016-02-04 Jan from Planio www.plan.io

Overview - Sub-Subproject with a very long name - Redmine 2016-02-04 14-50-43.png161 KB 2016-02-04 Jan from Planio www.plan.io

Overview - Sub-Subproject with a very long name - Redmine 2016-02-04 14-51-33.png155 KB 2016-02-04 Jan from Planio www.plan.io

screenshot-font-comparison.png 52.5 KB 2016-02-05 Go MAEDA

2016-11-30_new_redmine_header.png 10.1 KB 2016-11-30 Ben Blanco

2016-11-30_old_redmine_header.png 12.2 KB 2016-11-30 Ben Blanco
